<?php 
// Filteration of result
add_action( 'wp_ajax_nopriv_action_shortcode_listing_filters', 'action_shortcode_listing_filters_fn' );
add_action( 'wp_ajax_action_shortcode_listing_filters', 'action_shortcode_listing_filters_fn' );

function action_shortcode_listing_filters_fn(){
    // Bring in the products  
    if(is_array($_POST['formdata'])){
        $limit_post = $_POST['formdata']['limit'];
        $offset_post = $_POST['formdata']['offset'];
        $shortcode_id_post = $_POST['formdata']['shortcode_id'];
        $search_post = $_POST['formdata']['search'];
        $cats_locatie = $_POST['formdata']['cats-Locatie'];
        $current_page_id = $_POST['formdata']['current_page_id'];

        if(get_post_meta( $shortcode_id_post, '_api_selected_filters', true )){
            $cat_filter_arr = [];
            $api_selected_filters = get_post_meta( $shortcode_id_post, '_api_selected_filters', true );
            $kk = 1;
            foreach ($api_selected_filters as $value_fltr){
                if($_POST['formdata']['cats-'.$value_fltr.'']){
                    $cat_filter_arr[$kk]['name'] = $value_fltr;
                    $cat_filter_arr[$kk]['value'] = $_POST['formdata']['cats-'.$value_fltr.''];
                    $kk++;
                }
            }
        }

    }else{
        $formdata = array();
        parse_str($_POST['formdata'], $formdata);
        //print_r($formdata);
        
        $shortcode_id_post = $formdata['shortcode_id'];
        $search_post = $formdata['search'];
        $cats_locatie = $formdata['cats-Locatie'];
        $current_page_id = $formdata['current_page_id'];

        if(get_post_meta( $shortcode_id_post, '_api_selected_filters', true )){
            $cat_filter_arr = [];
            $api_selected_filters = get_post_meta( $shortcode_id_post, '_api_selected_filters', true );
            $k = 1;
            foreach ($api_selected_filters as $value_fltr){
                if($formdata['cats-'.$value_fltr.'']){
                    $cat_filter_arr[$k]['name'] = $value_fltr;
                    $cat_filter_arr[$k]['value'] = $formdata['cats-'.$value_fltr.''];
                    $k++;
                }  
            }
        }        
    }

    //print_r($cat_filter_arr);
    
    $portal_id = get_post_meta( $shortcode_id_post, '_api_portal_id', true );
    $developer_key = get_post_meta( $shortcode_id_post, '_api_developer_key', true );
    $language_id = get_post_meta( $shortcode_id_post, '_api_language_id', true );
    $appdata = [
      'portalId' => $portal_id,
      'developerKey' => $developer_key,
      'keywords' => '',
      'location' => '',
      'categoryId' => '',
      'educationLevelId' => '',
      'languageId' => $language_id,
    ];
    $client = new SoapClient("https://api.hroffice.nl/HROfficeCoreService.asmx?wsdl");        
    $resp = $client->GetAllJobByLanguage($appdata);
    $products = $resp->GetAllJobByLanguageResult->Results->AvJobSearch; 

    // Filters
    $cat_filter = isset($cats_locatie) ? $cats_locatie : '';
    $search_filter = isset($search_post) ? $search_post : '';
    $limit_count = get_post_meta( $shortcode_id_post, '_api_loadmore_limit', true );
    $view_job_button_text = get_post_meta( $shortcode_id_post, '_list_view_job_button_text', true );
    $load_more_button_text = get_post_meta( $shortcode_id_post, '_list_load_more_button_text', true );

    // Default limit
    $limit = isset($limit_post) ? $limit_post : $limit_count;

    // Default offset
    $offset = isset($offset_post) ? $offset_post : 0;

    $api_selected_job_data = get_post_meta( $shortcode_id_post, '_api_selected_job_data', true );


    if(!empty($cat_filter_arr) || !empty($search_filter)) {
      $filtered_productss = array();

        foreach($products as $product) {            

            foreach($cat_filter_arr as $kycat => $catvl){
                if($catvl['name'] == 'Locatie'){
                    ${"productval" . $kycat} = $product->Location;
                }elseif($catvl['name'] == 'Uren'){
                    ${"productval" . $kycat} = $product->MinHour.'-'.$product->MaxHour;
                }else{
                    ${"productval" . $kycat} = $product->$catvl['name'];                    
                }
                ${"catvalue" . $kycat} = $catvl['value'];
            }                         

            if( !empty($cat_filter_arr) && empty($search_filter) ) {  
                
                if(count($cat_filter_arr) == 1){
                    if( strstr($productval1, str_replace(' ', '', $catvalue1)) !== false ) {
                        $filtered_productss[] = (array)$product;                                         
                    }    
                }elseif(count($cat_filter_arr) == 2){ 
                    if( (strstr($productval1, str_replace(' ', '', $catvalue1)) !== false) && ( strstr($productval2, str_replace(' ', '', $catvalue2)) !== false ) ) {
                        $filtered_productss[] = (array)$product;                                         
                    }    
                }elseif(count($cat_filter_arr) == 3){ 
                    if( (strstr($productval1, str_replace(' ', '', $catvalue1)) !== false) && ( strstr($productval2, str_replace(' ', '', $catvalue2)) !== false ) && ( strstr($productval3, str_replace(' ', '', $catvalue3)) !== false ) ) {
                        $filtered_productss[] = (array)$product;                                         
                    }    
                }elseif(count($cat_filter_arr) == 4){ 
                    if( (strstr($productval1, str_replace(' ', '', $catvalue1)) !== false) && ( strstr($productval2, str_replace(' ', '', $catvalue2)) !== false ) && ( strstr($productval3, str_replace(' ', '', $catvalue3)) !== false ) && ( strstr($productval4, str_replace(' ', '', $catvalue4)) !== false ) ) {
                        $filtered_productss[] = (array)$product;                                         
                    }    
                }                            

            }            
            elseif( !empty($cat_filter_arr) && !empty($search_filter) ) {               
                
                if(count($cat_filter_arr) == 1){
                    if( ( strstr($productval1, str_replace(' ', '', $catvalue1)) !== false ) && ( stripos($product->Title, $search_filter) !== false) ) {
                        $filtered_productss[] = (array)$product;                                         
                    } 
                }elseif(count($cat_filter_arr) == 2){
                    if( ( strstr($productval1, str_replace(' ', '', $catvalue1)) !== false) && ( strstr($productval2, str_replace(' ', '', $catvalue2)) !== false ) && ( stripos($product->Title, $search_filter) !== false ) ) {
                        $filtered_productss[] = (array)$product;                                         
                    } 
                }elseif(count($cat_filter_arr) == 3){
                    if( ( strstr($productval1, str_replace(' ', '', $catvalue1)) !== false) && ( strstr($productval2, str_replace(' ', '', $catvalue2)) !== false ) && ( strstr($productval3, str_replace(' ', '', $catvalue3)) !== false ) && ( stripos($product->Title, $search_filter) !== false ) ) {
                        $filtered_productss[] = (array)$product;                                         
                    } 
                }elseif(count($cat_filter_arr) == 4){
                    if( ( strstr($productval1, str_replace(' ', '', $catvalue1)) !== false) && ( strstr($productval2, str_replace(' ', '', $catvalue2)) !== false ) && ( strstr($productval3, str_replace(' ', '', $catvalue3)) !== false ) && ( strstr($productval4, str_replace(' ', '', $catvalue4)) !== false ) && ( stripos($product->Title, $search_filter) !== false ) ) {
                        $filtered_productss[] = (array)$product;                                         
                    } 
                }             
                
                 
            }
            elseif(!empty($search_filter) && empty($cat_filter_arr)){             

                if( stripos($product->Title, $search_filter) !== false ) {
                
                    $filtered_productss[] = (array)$product;
                }                               
            
            }
            
        }
        
           
        
      $products = $filtered_productss;
      //print_r($products);

    }

    // filter products array based on query
    /*if(!empty($cat_filter) || !empty($search_filter)) {
        $filtered_products = array();
        foreach($products as $product) {
            if( !empty($cat_filter) && !empty($search_filter) ) {
                
                if( ( stripos($product->Title, $search_filter) !== false ) && ( strstr($product->Location, $cat_filter) !== false ) ) {
                    $filtered_products[] = (array)$product;
                }

            }
            else if(!empty($cat_filter) && ( strstr($product->Location, $cat_filter) !== false ) ) {

                $filtered_products[] = (array)$product;
            }
            else if(!empty($search_filter) && ( stripos($product->Title, $search_filter) !== false ) ) {
                
                $filtered_products[] = (array)$product;
            }
            
        }
        
        $products = $filtered_products;
    }*/



    $queried_products = array_slice($products, $offset, $limit);

    $total_products = count($products);

    // Get the total rows rounded up the nearest whole number
    $total_rows = (int)ceil( $total_products / $limit );

    $current_row = !$offset ? 1 : ( $offset / $limit ) + 1;   


    if (count($queried_products)) {
        $replace_param_list = array(" ", "(", ")", "-", "/");
        
        foreach ($queried_products as $product) {  
            $product1 = (array)$product; 
        ?>
           
           <div class="vacancies-list-row">
               <div class="job-list">                   
                    <a class="inner-job-list" href="<?php echo get_permalink($current_page_id).$product1['Id'].'-'.str_replace($replace_param_list, '', $product1['Title']).'-'.$shortcode_id_post; ?>">
                        <?php
                        $api_template_selected = get_post_meta( $shortcode_id_post, '_api_template_selected', true );
                        $findonstring = array(" ","/"); 
                        $catlist_img_meta_key = '_api_job_data_category_list_image_'.str_replace($findonstring, '_', $product1['CategoryList']->IdNamePair->Name);
                        $api_job_data_category_list_image = get_post_meta( $shortcode_id_post, $catlist_img_meta_key, true );
                        if($api_job_data_category_list_image){
                            $category_list_image = wp_get_attachment_image_url($api_job_data_category_list_image, 'large');
                        }else{
                            $category_list_image = plugin_dir_url( __DIR__ ).'assets/img/job-placeholder-new.jpg';
                        }

                        if($api_template_selected == 'grid'):
                        ?>
                        <div class="list-img">                            
                            <img src="<?php echo $category_list_image; ?>">
                        </div>
                        <?php
                        endif;
                        ?>
                        
                        <div class="list-content"> 
                            <h5><?php echo $product1['Title']; ?></h5>
                            <div class="list-detail">
                                <ul>                                             
                                    <?php 
                                    foreach ($api_selected_job_data as $value_s){ 
                                                        //print_r($product1);
                                        if($value_s == 'RegionsList'){
                                            $val_name = $product1['RegionsList']->AvRegion->Name;
                                        }elseif($value_s == 'IndustryList'){
                                            $val_name = $product1['IndustryList']->AvIndustry->Name;
                                        }elseif($value_s == 'CategoryList'){
                                            $val_name = $product1['CategoryList']->IdNamePair->Name;
                                        }elseif($value_s == 'Education'){
                                            $val_name = $product1['Education']->Name;
                                        }elseif($value_s == 'ContractTime'){
                                            $val_name = $product1['ContractTime']->Name;
                                        }elseif($value_s == 'PublishDate'){
                                            $val_name = date("d-m-Y", strtotime($product1['PublishDate']));
                                        }elseif($value_s == 'EndDate'){
                                            $val_name = date("d-m-Y", strtotime($product1['EndDate']));
                                        }else{
                                            $val_name = $product1[$value_s];
                                        }

                                        $api_jobdtl_label = get_post_meta( $shortcode_id_post, '_api_job_listing_data_label_'.$value_s.'', true );
                                        //echo $api_jobdtl_label;
                                        if($api_jobdtl_label){
                                            $api_job_dtl_label_name = $api_jobdtl_label.': ';
                                        }else{
                                            $api_job_dtl_label_name = '';
                                        }
                                    ?>
                                       <li <?php if($val_name == ''){echo 'style="display:none;"'; } ?>><strong><?php echo $api_job_dtl_label_name; ?></strong><?php if($val_name){ echo $val_name; }else{ echo 'N/A'; } ?></li>
                                    <?php } ?>
                                </ul>                            
                            </div>
                            <p class="link"><?php echo __($view_job_button_text,'hr_office_vacancy_domain'); ?></p>    
                        </div>
                    </a>
               </div>
               
           </div>
               
         <?php }
    
    }else{

       echo '<h4 class="no-result">'.__('No Result Found','hr_office_vacancy_domain').'</h4>';
       
    }

    if ( $current_row < $total_rows ) { ?>
        
        <div class="view-more-button">
            <button id="load-more" class=""><?php echo __($load_more_button_text,'hr_office_vacancy_domain'); ?></button>
        </div>
        
    <?php 
    }else{

        echo '';
    }

    exit();
}